//#line 2 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the ros_speech_recognition package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __ros_speech_recognition__SPEECHRECOGNITIONCONFIG_H__
#define __ros_speech_recognition__SPEECHRECOGNITIONCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace ros_speech_recognition
{
  class SpeechRecognitionConfigStatics;

  class SpeechRecognitionConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      virtual ~AbstractParamDescription() = default;

      virtual void clamp(SpeechRecognitionConfig &config, const SpeechRecognitionConfig &max, const SpeechRecognitionConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const SpeechRecognitionConfig &config1, const SpeechRecognitionConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, SpeechRecognitionConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const SpeechRecognitionConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, SpeechRecognitionConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const SpeechRecognitionConfig &config) const = 0;
      virtual void getValue(const SpeechRecognitionConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T SpeechRecognitionConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T SpeechRecognitionConfig::* field;

      virtual void clamp(SpeechRecognitionConfig &config, const SpeechRecognitionConfig &max, const SpeechRecognitionConfig &min) const override
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const SpeechRecognitionConfig &config1, const SpeechRecognitionConfig &config2) const override
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, SpeechRecognitionConfig &config) const override
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const SpeechRecognitionConfig &config) const override
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, SpeechRecognitionConfig &config) const override
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const SpeechRecognitionConfig &config) const override
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const SpeechRecognitionConfig &config, boost::any &val) const override
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      virtual ~AbstractGroupDescription() = default;

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, SpeechRecognitionConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, SpeechRecognitionConfig &top) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const override
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T PT::* field;
      std::vector<SpeechRecognitionConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(SpeechRecognitionConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("language"==(*_i)->name){language = boost::any_cast<std::string>(val);}
        if("engine"==(*_i)->name){engine = boost::any_cast<std::string>(val);}
        if("energy_threshold"==(*_i)->name){energy_threshold = boost::any_cast<double>(val);}
        if("dynamic_energy_threshold"==(*_i)->name){dynamic_energy_threshold = boost::any_cast<bool>(val);}
        if("dynamic_energy_adjustment_damping"==(*_i)->name){dynamic_energy_adjustment_damping = boost::any_cast<double>(val);}
        if("dynamic_energy_ratio"==(*_i)->name){dynamic_energy_ratio = boost::any_cast<double>(val);}
        if("pause_threshold"==(*_i)->name){pause_threshold = boost::any_cast<double>(val);}
        if("operation_timeout"==(*_i)->name){operation_timeout = boost::any_cast<double>(val);}
        if("listen_timeout"==(*_i)->name){listen_timeout = boost::any_cast<double>(val);}
        if("phrase_time_limit"==(*_i)->name){phrase_time_limit = boost::any_cast<double>(val);}
        if("phrase_threshold"==(*_i)->name){phrase_threshold = boost::any_cast<double>(val);}
        if("non_speaking_duration"==(*_i)->name){non_speaking_duration = boost::any_cast<double>(val);}
      }
    }

    std::string language;
std::string engine;
double energy_threshold;
bool dynamic_energy_threshold;
double dynamic_energy_adjustment_damping;
double dynamic_energy_ratio;
double pause_threshold;
double operation_timeout;
double listen_timeout;
double phrase_time_limit;
double phrase_threshold;
double non_speaking_duration;

    bool state;
    std::string name;

    
}groups;



//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string language;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string engine;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double energy_threshold;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool dynamic_energy_threshold;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double dynamic_energy_adjustment_damping;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double dynamic_energy_ratio;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double pause_threshold;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double operation_timeout;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double listen_timeout;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double phrase_time_limit;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double phrase_threshold;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double non_speaking_duration;
//#line 231 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("SpeechRecognitionConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const SpeechRecognitionConfig &__max__ = __getMax__();
      const SpeechRecognitionConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const SpeechRecognitionConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const SpeechRecognitionConfig &__getDefault__();
    static const SpeechRecognitionConfig &__getMax__();
    static const SpeechRecognitionConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const SpeechRecognitionConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void SpeechRecognitionConfig::ParamDescription<std::string>::clamp(SpeechRecognitionConfig &config, const SpeechRecognitionConfig &max, const SpeechRecognitionConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class SpeechRecognitionConfigStatics
  {
    friend class SpeechRecognitionConfig;

    SpeechRecognitionConfigStatics()
    {
SpeechRecognitionConfig::GroupDescription<SpeechRecognitionConfig::DEFAULT, SpeechRecognitionConfig> Default("Default", "", 0, 0, true, &SpeechRecognitionConfig::groups);
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.language = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.language = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.language = "en-US";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<std::string>("language", "str", 0, "Language", "", &SpeechRecognitionConfig::language)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<std::string>("language", "str", 0, "Language", "", &SpeechRecognitionConfig::language)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.engine = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.engine = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.engine = "Google";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<std::string>("engine", "str", 0, "Recognition Engine", "{'enum': [{'name': 'Google', 'type': 'str', 'value': 'Google', 'srcline': 7, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Google Speech Recognition API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'GoogleCloud', 'type': 'str', 'value': 'GoogleCloud', 'srcline': 8, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Google Cloud Speech API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Sphinx', 'type': 'str', 'value': 'Sphinx', 'srcline': 9, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'CMU Sphinx API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Wit', 'type': 'str', 'value': 'Wit', 'srcline': 10, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Wit.ai API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Bing', 'type': 'str', 'value': 'Bing', 'srcline': 11, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Microsoft Bing Speech API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Houndify', 'type': 'str', 'value': 'Houndify', 'srcline': 12, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Houndify API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'IBM', 'type': 'str', 'value': 'IBM', 'srcline': 13, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'IBM Speech to Text API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Vosk', 'type': 'str', 'value': 'Vosk', 'srcline': 14, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Vosk API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'engine'}", &SpeechRecognitionConfig::engine)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<std::string>("engine", "str", 0, "Recognition Engine", "{'enum': [{'name': 'Google', 'type': 'str', 'value': 'Google', 'srcline': 7, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Google Speech Recognition API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'GoogleCloud', 'type': 'str', 'value': 'GoogleCloud', 'srcline': 8, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Google Cloud Speech API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Sphinx', 'type': 'str', 'value': 'Sphinx', 'srcline': 9, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'CMU Sphinx API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Wit', 'type': 'str', 'value': 'Wit', 'srcline': 10, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Wit.ai API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Bing', 'type': 'str', 'value': 'Bing', 'srcline': 11, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Microsoft Bing Speech API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Houndify', 'type': 'str', 'value': 'Houndify', 'srcline': 12, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Houndify API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'IBM', 'type': 'str', 'value': 'IBM', 'srcline': 13, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'IBM Speech to Text API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'Vosk', 'type': 'str', 'value': 'Vosk', 'srcline': 14, 'srcfile': '/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg', 'description': 'Vosk API', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'engine'}", &SpeechRecognitionConfig::engine)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.energy_threshold = 10.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.energy_threshold = 2000.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.energy_threshold = 300.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("energy_threshold", "double", 0, "Threshold for Voice activity detection", "", &SpeechRecognitionConfig::energy_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("energy_threshold", "double", 0, "Threshold for Voice activity detection", "", &SpeechRecognitionConfig::energy_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.dynamic_energy_threshold = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.dynamic_energy_threshold = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.dynamic_energy_threshold = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<bool>("dynamic_energy_threshold", "bool", 0, "Adaptive estimation for energy_threshold", "", &SpeechRecognitionConfig::dynamic_energy_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<bool>("dynamic_energy_threshold", "bool", 0, "Adaptive estimation for energy_threshold", "", &SpeechRecognitionConfig::dynamic_energy_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.dynamic_energy_adjustment_damping = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.dynamic_energy_adjustment_damping = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.dynamic_energy_adjustment_damping = 0.15;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("dynamic_energy_adjustment_damping", "double", 0, "Damping threshold for dynamic VAD", "", &SpeechRecognitionConfig::dynamic_energy_adjustment_damping)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("dynamic_energy_adjustment_damping", "double", 0, "Damping threshold for dynamic VAD", "", &SpeechRecognitionConfig::dynamic_energy_adjustment_damping)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.dynamic_energy_ratio = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.dynamic_energy_ratio = 10.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.dynamic_energy_ratio = 1.5;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("dynamic_energy_ratio", "double", 0, "Energy ratio for dynamic VAD", "", &SpeechRecognitionConfig::dynamic_energy_ratio)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("dynamic_energy_ratio", "double", 0, "Energy ratio for dynamic VAD", "", &SpeechRecognitionConfig::dynamic_energy_ratio)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pause_threshold = 0.3;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pause_threshold = 2.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pause_threshold = 0.8;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("pause_threshold", "double", 0, "Seconds of non-speaking audio before a phrase is considered complete", "", &SpeechRecognitionConfig::pause_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("pause_threshold", "double", 0, "Seconds of non-speaking audio before a phrase is considered complete", "", &SpeechRecognitionConfig::pause_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.operation_timeout = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.operation_timeout = 60.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.operation_timeout = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("operation_timeout", "double", 0, "Seconds after an internal operation (e.g., an API request) starts before it times out", "", &SpeechRecognitionConfig::operation_timeout)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("operation_timeout", "double", 0, "Seconds after an internal operation (e.g., an API request) starts before it times out", "", &SpeechRecognitionConfig::operation_timeout)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.listen_timeout = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.listen_timeout = 60.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.listen_timeout = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("listen_timeout", "double", 0, "The maximum number of seconds that this will wait for a phrase to start before giving up", "", &SpeechRecognitionConfig::listen_timeout)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("listen_timeout", "double", 0, "The maximum number of seconds that this will wait for a phrase to start before giving up", "", &SpeechRecognitionConfig::listen_timeout)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.phrase_time_limit = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.phrase_time_limit = 30.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.phrase_time_limit = 10.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("phrase_time_limit", "double", 0, "The maximum number of seconds that this will allow a phrase to continue before stopping and returning the part of the phrase processed before the time limit was reached", "", &SpeechRecognitionConfig::phrase_time_limit)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("phrase_time_limit", "double", 0, "The maximum number of seconds that this will allow a phrase to continue before stopping and returning the part of the phrase processed before the time limit was reached", "", &SpeechRecognitionConfig::phrase_time_limit)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.phrase_threshold = 0.001;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.phrase_threshold = 2.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.phrase_threshold = 0.3;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("phrase_threshold", "double", 0, "Minimum seconds of speaking audio before we consider the speaking audio a phrase", "", &SpeechRecognitionConfig::phrase_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("phrase_threshold", "double", 0, "Minimum seconds of speaking audio before we consider the speaking audio a phrase", "", &SpeechRecognitionConfig::phrase_threshold)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.non_speaking_duration = 0.1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.non_speaking_duration = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.non_speaking_duration = 0.5;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("non_speaking_duration", "double", 0, "Seconds of non-speaking audio to keep on both sides of the recording", "", &SpeechRecognitionConfig::non_speaking_duration)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(SpeechRecognitionConfig::AbstractParamDescriptionConstPtr(new SpeechRecognitionConfig::ParamDescription<double>("non_speaking_duration", "double", 0, "Seconds of non-speaking audio to keep on both sides of the recording", "", &SpeechRecognitionConfig::non_speaking_duration)));
//#line 246 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 246 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(SpeechRecognitionConfig::AbstractGroupDescriptionConstPtr(new SpeechRecognitionConfig::GroupDescription<SpeechRecognitionConfig::DEFAULT, SpeechRecognitionConfig>(Default)));
//#line 369 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<SpeechRecognitionConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<SpeechRecognitionConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<SpeechRecognitionConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    SpeechRecognitionConfig __max__;
    SpeechRecognitionConfig __min__;
    SpeechRecognitionConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const SpeechRecognitionConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static SpeechRecognitionConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &SpeechRecognitionConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const SpeechRecognitionConfig &SpeechRecognitionConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const SpeechRecognitionConfig &SpeechRecognitionConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const SpeechRecognitionConfig &SpeechRecognitionConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<SpeechRecognitionConfig::AbstractParamDescriptionConstPtr> &SpeechRecognitionConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<SpeechRecognitionConfig::AbstractGroupDescriptionConstPtr> &SpeechRecognitionConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const SpeechRecognitionConfigStatics *SpeechRecognitionConfig::__get_statics__()
  {
    const static SpeechRecognitionConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = SpeechRecognitionConfigStatics::get_instance();

    return statics;
  }

//#line 7 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_Google = "Google";
//#line 8 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_GoogleCloud = "GoogleCloud";
//#line 9 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_Sphinx = "Sphinx";
//#line 10 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_Wit = "Wit";
//#line 11 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_Bing = "Bing";
//#line 12 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_Houndify = "Houndify";
//#line 13 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_IBM = "IBM";
//#line 14 "/tmp/binarydeb/ros-noetic-ros-speech-recognition-2.1.28/cfg/SpeechRecognition.cfg"
      const char * const SpeechRecognition_Vosk = "Vosk";
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __SPEECHRECOGNITIONRECONFIGURATOR_H__
